/**
 * ai.jsx (c)MaratShagiev m_js@bk.ru 30.01.2016.
 *
 * The script centered all objects on each Artboard
 *
 * Compatible with Illustrator CC and hi (maybe cs6 too)
 *
 * IMPORTANT!
 * Before run the script
 * in palette "Aling"
 * switch the checkbox "Aling to:"
 * to "Align to Artboard"
 */

var align_hor_str = align_hor_act (),
    align_ver_str = align_ver_act (),
    i;

loadAct (align_hor_str);
loadAct (align_ver_str);

executeMenuCommand ('deselectall');

for (i = 0; i < activeDocument.artboards.length; i++) {
  activeDocument.artboards.setActiveArtboardIndex (i);
  app.executeMenuCommand ('selectallinartboard');
  doScript ('align_horizontal', 'align_horizontal');
  executeMenuCommand ('deselectall');
}

for (i = 0; i < activeDocument.artboards.length; i++) {
  activeDocument.artboards.setActiveArtboardIndex (i);
  app.executeMenuCommand ('selectallinartboard');
  doScript ('align_vertical', 'align_vertical');
  executeMenuCommand ('deselectall');
}

unloadAction ('align_horizontal', '');
unloadAction ('align_vertical', '');

function loadAct (str) {
  var f = new File ('~/ScriptAction.aia');
  f.open('w');
  f.write(str);
  f.close();
  loadAction (f);
  f.remove();
}

function align_hor_act () {
  return [
    '/version 3',
    '/name [ 16',
    '	616c69676e5f686f72697a6f6e74616c',
    ']',
    '/isOpen 0',
    '/actionCount 1',
    '/action-1 {',
    '	/name [ 16',
    '		616c69676e5f686f72697a6f6e74616c',
    '	]',
    '	/keyIndex 0',
    '	/colorIndex 0',
    '	/isOpen 1',
    '	/eventCount 1',
    '	/event-1 {',
    '		/useRulersIn1stQuadrant 0',
    '		/internalName (ai_plugin_alignPalette)',
    '		/localizedName [ 9',
    '			416c69676e6d656e74',
    '		]',
    '		/isOpen 0',
    '		/isOn 1',
    '		/hasDialog 0',
    '		/parameterCount 1',
    '		/parameter-1 {',
    '			/key 1954115685',
    '			/showInPalette -1',
    '			/type (enumerated)',
    '			/name [ 23',
    '				486f72697a6f6e74616c20416c69676e2043656e746572',
    '			]',
    '			/value 2',
    '		}',
    '	}',
    '}'
  ].join('\n');
}
function align_ver_act () {
  return [
    '/version 3',
    '/name [ 14',
    '	616c69676e5f766572746963616c',
    ']',
    '/isOpen 1',
    '/actionCount 1',
    '/action-1 {',
    '	/name [ 14',
    '		616c69676e5f766572746963616c',
    '	]',
    '	/keyIndex 0',
    '	/colorIndex 0',
    '	/isOpen 1',
    '	/eventCount 1',
    '	/event-1 {',
    '		/useRulersIn1stQuadrant 0',
    '		/internalName (ai_plugin_alignPalette)',
    '		/localizedName [ 9',
    '			416c69676e6d656e74',
    '		]',
    '		/isOpen 1',
    '		/isOn 1',
    '		/hasDialog 0',
    '		/parameterCount 1',
    '		/parameter-1 {',
    '			/key 1954115685',
    '			/showInPalette -1',
    '			/type (enumerated)',
    '			/name [ 21',
    '				566572746963616c20416c69676e2043656e746572',
    '			]',
    '			/value 5',
    '		}',
    '	}',
    '}'
  ].join('\n');
}
